/**
This file is part of a jTEM project.
All jTEM projects are licensed under the FreeBSD license 
or 2-clause BSD license (see http://www.opensource.org/licenses/bsd-license.php). 

Copyright (c) 2006-2009, Technische Universität Berlin, jTEM
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

-	Redistributions of source code must retain the above copyright notice, 
	this list of conditions and the following disclaimer.

-	Redistributions in binary form must reproduce the above copyright notice, 
	this list of conditions and the following disclaimer in the documentation 
	and/or other materials provided with the distribution.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS 
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
OF SUCH DAMAGE.
**/

package de.jtem.moebiusViewer;

import de.jtem.mfc.geometry.ComplexProjective1;
import de.jtem.mfc.geometry.HermitianCircle;

public class RenderTreeInfo extends MoebiusGraphics {
    static final private long serialVersionUID = 1L;

    static RenderTreeInfo renderTreeInfo = new RenderTreeInfo();

    MoebiusShape shape;

    boolean containsShape;

    public MoebiusShape push (MoebiusShape aShape) {
	
	if( aShape == shape )
	    containsShape = true;

	return super.push( aShape );
    } 

    public void initContainingTest( MoebiusShape shape ) {
	this.shape = shape;
	containsShape = false;
    } 


    static public boolean contains( MoebiusShape shape, MoebiusShape testShape ) {
      renderTreeInfo.push( shape );
      renderTreeInfo.initContainingTest( testShape );
      shape.draw( renderTreeInfo );
      renderTreeInfo.popShape();
      return renderTreeInfo.containsShape;
    }

    public void point (ComplexProjective1 z){}
    public void lineSeg (ComplexProjective1 z1, ComplexProjective1 z2){}
    public void text  (ComplexProjective1 z, String s ){}
    public void circle (HermitianCircle c){}
    public void arc (ComplexProjective1 z1, ComplexProjective1 z2, ComplexProjective1 z3){}
}

