/**
This file is part of a jTEM project.
All jTEM projects are licensed under the FreeBSD license 
or 2-clause BSD license (see http://www.opensource.org/licenses/bsd-license.php). 

Copyright (c) 2006-2009, Technische Universität Berlin, jTEM
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

-	Redistributions of source code must retain the above copyright notice, 
	this list of conditions and the following disclaimer.

-	Redistributions in binary form must reproduce the above copyright notice, 
	this list of conditions and the following disclaimer in the documentation 
	and/or other materials provided with the distribution.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS 
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
OF SUCH DAMAGE.
**/

package de.jtem.moebiusViewer.moebius;

import de.jtem.mfc.geometry.ComplexProjective1;
import de.jtem.mfc.geometry.HermitianCircle;
import de.jtem.moebiusViewer.AbstractPSWriter;
import de.jtem.moebiusViewer.Attributes;

public class MoebiusPSWriter extends AbstractPSWriter {

    private static final long     serialVersionUID = 1L;

    public MoebiusPSWriter( Attributes att ) {	
	super( att );
    }

    public void point( ComplexProjective1 aZ ) {
	MoebiusDrawer.point( this, aZ );
    }

    public void circle ( HermitianCircle aC){
	MoebiusDrawer.circle( this, aC );
    }
    
    public void lineSeg( ComplexProjective1 aZ, ComplexProjective1 aW) {
	MoebiusDrawer.lineSeg( this, aZ, aW );
    }

    public void arc( ComplexProjective1 z1, ComplexProjective1 z2, ComplexProjective1 z3){
	MoebiusDrawer.arc( this, z1, z2, z3 );
    }

    public void text( ComplexProjective1 cp, String s) {
	MoebiusDrawer.text( this, cp, s );
    }

}






